<?php
/**
 * AccountingExpensesApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use \Swagger\Client\ApiClient;
use \Swagger\Client\ApiException;
use \Swagger\Client\Configuration;
use \Swagger\Client\ObjectSerializer;

/**
 * AccountingExpensesApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class AccountingExpensesApi
{
    /**
     * API Client
     *
     * @var \Swagger\Client\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Swagger\Client\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Swagger\Client\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
            $apiClient->getConfig()->setHost('http://api.prelive.contasimple.com');
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Swagger\Client\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Swagger\Client\ApiClient $apiClient set the API client
     *
     * @return AccountingExpensesApi
     */
    public function setApiClient(\Swagger\Client\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation accountingExpensesAttach
     *
     * Attaches a file or files to the given expense
     *
     * @param int $expense_id The identifier of the expense to attach files to (required)
     * @param string $version  (required)
     * @param string $period  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\ApiListResultFileApiModel
     */
    public function accountingExpensesAttach($expense_id, $version, $period)
    {
        list($response) = $this->accountingExpensesAttachWithHttpInfo($expense_id, $version, $period);
        return $response;
    }

    /**
     * Operation accountingExpensesAttachWithHttpInfo
     *
     * Attaches a file or files to the given expense
     *
     * @param int $expense_id The identifier of the expense to attach files to (required)
     * @param string $version  (required)
     * @param string $period  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\ApiListResultFileApiModel, HTTP status code, HTTP response headers (array of strings)
     */
    public function accountingExpensesAttachWithHttpInfo($expense_id, $version, $period)
    {
        // verify the required parameter 'expense_id' is set
        if ($expense_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $expense_id when calling accountingExpensesAttach');
        }
        // verify the required parameter 'version' is set
        if ($version === null) {
            throw new \InvalidArgumentException('Missing the required parameter $version when calling accountingExpensesAttach');
        }
        // verify the required parameter 'period' is set
        if ($period === null) {
            throw new \InvalidArgumentException('Missing the required parameter $period when calling accountingExpensesAttach');
        }
        // parse inputs
        $resourcePath = "/api/v{version}/accounting/{period}/expenses/{expenseId}/attach";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json', 'text/json', 'text/html', 'application/xml', 'text/xml']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($expense_id !== null) {
            $resourcePath = str_replace(
                "{" . "expenseId" . "}",
                $this->apiClient->getSerializer()->toPathValue($expense_id),
                $resourcePath
            );
        }
        // path params
        if ($version !== null) {
            $resourcePath = str_replace(
                "{" . "version" . "}",
                $this->apiClient->getSerializer()->toPathValue($version),
                $resourcePath
            );
        }
        // path params
        if ($period !== null) {
            $resourcePath = str_replace(
                "{" . "period" . "}",
                $this->apiClient->getSerializer()->toPathValue($period),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\ApiListResultFileApiModel',
                '/api/v{version}/accounting/{period}/expenses/{expenseId}/attach'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\ApiListResultFileApiModel', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\ApiListResultFileApiModel', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation accountingExpensesCreateExpense
     *
     * Creates a new expense with the given information
     *
     * @param string $period The period where to create the expense (required)
     * @param \Swagger\Client\Model\CreateExpenseApiModel $expense The expense information (required)
     * @param string $version  (required)
     * @param bool $bypass_invoice_duplicate_validation Bypass the duplicate expenses check by expense number, provider and year. Default to false. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\ApiResultExpenseApiModel
     */
    public function accountingExpensesCreateExpense($period, $expense, $version, $bypass_invoice_duplicate_validation = null)
    {
        list($response) = $this->accountingExpensesCreateExpenseWithHttpInfo($period, $expense, $version, $bypass_invoice_duplicate_validation);
        return $response;
    }

    /**
     * Operation accountingExpensesCreateExpenseWithHttpInfo
     *
     * Creates a new expense with the given information
     *
     * @param string $period The period where to create the expense (required)
     * @param \Swagger\Client\Model\CreateExpenseApiModel $expense The expense information (required)
     * @param string $version  (required)
     * @param bool $bypass_invoice_duplicate_validation Bypass the duplicate expenses check by expense number, provider and year. Default to false. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\ApiResultExpenseApiModel, HTTP status code, HTTP response headers (array of strings)
     */
    public function accountingExpensesCreateExpenseWithHttpInfo($period, $expense, $version, $bypass_invoice_duplicate_validation = null)
    {
        // verify the required parameter 'period' is set
        if ($period === null) {
            throw new \InvalidArgumentException('Missing the required parameter $period when calling accountingExpensesCreateExpense');
        }
        // verify the required parameter 'expense' is set
        if ($expense === null) {
            throw new \InvalidArgumentException('Missing the required parameter $expense when calling accountingExpensesCreateExpense');
        }
        // verify the required parameter 'version' is set
        if ($version === null) {
            throw new \InvalidArgumentException('Missing the required parameter $version when calling accountingExpensesCreateExpense');
        }
        // parse inputs
        $resourcePath = "/api/v{version}/accounting/{period}/expenses";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json', 'text/json', 'text/html']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json', 'text/json', 'text/html', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded']);

        // query params
        if ($bypass_invoice_duplicate_validation !== null) {
            $queryParams['bypassInvoiceDuplicateValidation'] = $this->apiClient->getSerializer()->toQueryValue($bypass_invoice_duplicate_validation);
        }
        // path params
        if ($period !== null) {
            $resourcePath = str_replace(
                "{" . "period" . "}",
                $this->apiClient->getSerializer()->toPathValue($period),
                $resourcePath
            );
        }
        // path params
        if ($version !== null) {
            $resourcePath = str_replace(
                "{" . "version" . "}",
                $this->apiClient->getSerializer()->toPathValue($version),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        // body params
        $_tempBody = null;
        if (isset($expense)) {
            $_tempBody = $expense;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\ApiResultExpenseApiModel',
                '/api/v{version}/accounting/{period}/expenses'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\ApiResultExpenseApiModel', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\ApiResultExpenseApiModel', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation accountingExpensesDeleteExpense
     *
     * Deletes the given expense
     *
     * @param string $period The period where to create the expense (required)
     * @param int $expense_id The expense identifier to remove (required)
     * @param string $version  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\ApiResultInt64
     */
    public function accountingExpensesDeleteExpense($period, $expense_id, $version)
    {
        list($response) = $this->accountingExpensesDeleteExpenseWithHttpInfo($period, $expense_id, $version);
        return $response;
    }

    /**
     * Operation accountingExpensesDeleteExpenseWithHttpInfo
     *
     * Deletes the given expense
     *
     * @param string $period The period where to create the expense (required)
     * @param int $expense_id The expense identifier to remove (required)
     * @param string $version  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\ApiResultInt64, HTTP status code, HTTP response headers (array of strings)
     */
    public function accountingExpensesDeleteExpenseWithHttpInfo($period, $expense_id, $version)
    {
        // verify the required parameter 'period' is set
        if ($period === null) {
            throw new \InvalidArgumentException('Missing the required parameter $period when calling accountingExpensesDeleteExpense');
        }
        // verify the required parameter 'expense_id' is set
        if ($expense_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $expense_id when calling accountingExpensesDeleteExpense');
        }
        // verify the required parameter 'version' is set
        if ($version === null) {
            throw new \InvalidArgumentException('Missing the required parameter $version when calling accountingExpensesDeleteExpense');
        }
        // parse inputs
        $resourcePath = "/api/v{version}/accounting/{period}/expenses/{expenseId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json', 'text/json', 'text/html']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($period !== null) {
            $resourcePath = str_replace(
                "{" . "period" . "}",
                $this->apiClient->getSerializer()->toPathValue($period),
                $resourcePath
            );
        }
        // path params
        if ($expense_id !== null) {
            $resourcePath = str_replace(
                "{" . "expenseId" . "}",
                $this->apiClient->getSerializer()->toPathValue($expense_id),
                $resourcePath
            );
        }
        // path params
        if ($version !== null) {
            $resourcePath = str_replace(
                "{" . "version" . "}",
                $this->apiClient->getSerializer()->toPathValue($version),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\ApiResultInt64',
                '/api/v{version}/accounting/{period}/expenses/{expenseId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\ApiResultInt64', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\ApiResultInt64', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation accountingExpensesGet
     *
     * Gets the expense information for the given expense id
     *
     * @param int $expense_id The identifier of the expense to retrieve (required)
     * @param string $version  (required)
     * @param string $period  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\ApiResultExpenseApiModel
     */
    public function accountingExpensesGet($expense_id, $version, $period)
    {
        list($response) = $this->accountingExpensesGetWithHttpInfo($expense_id, $version, $period);
        return $response;
    }

    /**
     * Operation accountingExpensesGetWithHttpInfo
     *
     * Gets the expense information for the given expense id
     *
     * @param int $expense_id The identifier of the expense to retrieve (required)
     * @param string $version  (required)
     * @param string $period  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\ApiResultExpenseApiModel, HTTP status code, HTTP response headers (array of strings)
     */
    public function accountingExpensesGetWithHttpInfo($expense_id, $version, $period)
    {
        // verify the required parameter 'expense_id' is set
        if ($expense_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $expense_id when calling accountingExpensesGet');
        }
        // verify the required parameter 'version' is set
        if ($version === null) {
            throw new \InvalidArgumentException('Missing the required parameter $version when calling accountingExpensesGet');
        }
        // verify the required parameter 'period' is set
        if ($period === null) {
            throw new \InvalidArgumentException('Missing the required parameter $period when calling accountingExpensesGet');
        }
        // parse inputs
        $resourcePath = "/api/v{version}/accounting/{period}/expenses/{expenseId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json', 'text/json', 'text/html']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($expense_id !== null) {
            $resourcePath = str_replace(
                "{" . "expenseId" . "}",
                $this->apiClient->getSerializer()->toPathValue($expense_id),
                $resourcePath
            );
        }
        // path params
        if ($version !== null) {
            $resourcePath = str_replace(
                "{" . "version" . "}",
                $this->apiClient->getSerializer()->toPathValue($version),
                $resourcePath
            );
        }
        // path params
        if ($period !== null) {
            $resourcePath = str_replace(
                "{" . "period" . "}",
                $this->apiClient->getSerializer()->toPathValue($period),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\ApiResultExpenseApiModel',
                '/api/v{version}/accounting/{period}/expenses/{expenseId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\ApiResultExpenseApiModel', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\ApiResultExpenseApiModel', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation accountingExpensesList
     *
     * Gets the list of expenses for the current company
     *
     * @param string $period  (required)
     * @param string $version  (required)
     * @param int $start_index  (optional)
     * @param int $num_rows  (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\ApiListResultExpenseApiModel
     */
    public function accountingExpensesList($period, $version, $start_index = null, $num_rows = null)
    {
        list($response) = $this->accountingExpensesListWithHttpInfo($period, $version, $start_index, $num_rows);
        return $response;
    }

    /**
     * Operation accountingExpensesListWithHttpInfo
     *
     * Gets the list of expenses for the current company
     *
     * @param string $period  (required)
     * @param string $version  (required)
     * @param int $start_index  (optional)
     * @param int $num_rows  (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\ApiListResultExpenseApiModel, HTTP status code, HTTP response headers (array of strings)
     */
    public function accountingExpensesListWithHttpInfo($period, $version, $start_index = null, $num_rows = null)
    {
        // verify the required parameter 'period' is set
        if ($period === null) {
            throw new \InvalidArgumentException('Missing the required parameter $period when calling accountingExpensesList');
        }
        // verify the required parameter 'version' is set
        if ($version === null) {
            throw new \InvalidArgumentException('Missing the required parameter $version when calling accountingExpensesList');
        }
        // parse inputs
        $resourcePath = "/api/v{version}/accounting/{period}/expenses";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json', 'text/json', 'text/html', 'application/xml', 'text/xml']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($start_index !== null) {
            $queryParams['startIndex'] = $this->apiClient->getSerializer()->toQueryValue($start_index);
        }
        // query params
        if ($num_rows !== null) {
            $queryParams['numRows'] = $this->apiClient->getSerializer()->toQueryValue($num_rows);
        }
        // path params
        if ($period !== null) {
            $resourcePath = str_replace(
                "{" . "period" . "}",
                $this->apiClient->getSerializer()->toPathValue($period),
                $resourcePath
            );
        }
        // path params
        if ($version !== null) {
            $resourcePath = str_replace(
                "{" . "version" . "}",
                $this->apiClient->getSerializer()->toPathValue($version),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\ApiListResultExpenseApiModel',
                '/api/v{version}/accounting/{period}/expenses'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\ApiListResultExpenseApiModel', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\ApiListResultExpenseApiModel', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation accountingExpensesUpdateExpense
     *
     * Updates the given expense
     *
     * @param string $period The period where to update the expense (required)
     * @param int $expense_id The expense identifier to update (required)
     * @param \Swagger\Client\Model\UpdateExpenseApiModel $expense The expense information (required)
     * @param string $version  (required)
     * @param bool $bypass_invoice_duplicate_validation Bypass the duplicate expenses check by expense number, provider and year. Default to false. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\ApiResultInt64
     */
    public function accountingExpensesUpdateExpense($period, $expense_id, $expense, $version, $bypass_invoice_duplicate_validation = null)
    {
        list($response) = $this->accountingExpensesUpdateExpenseWithHttpInfo($period, $expense_id, $expense, $version, $bypass_invoice_duplicate_validation);
        return $response;
    }

    /**
     * Operation accountingExpensesUpdateExpenseWithHttpInfo
     *
     * Updates the given expense
     *
     * @param string $period The period where to update the expense (required)
     * @param int $expense_id The expense identifier to update (required)
     * @param \Swagger\Client\Model\UpdateExpenseApiModel $expense The expense information (required)
     * @param string $version  (required)
     * @param bool $bypass_invoice_duplicate_validation Bypass the duplicate expenses check by expense number, provider and year. Default to false. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\ApiResultInt64, HTTP status code, HTTP response headers (array of strings)
     */
    public function accountingExpensesUpdateExpenseWithHttpInfo($period, $expense_id, $expense, $version, $bypass_invoice_duplicate_validation = null)
    {
        // verify the required parameter 'period' is set
        if ($period === null) {
            throw new \InvalidArgumentException('Missing the required parameter $period when calling accountingExpensesUpdateExpense');
        }
        // verify the required parameter 'expense_id' is set
        if ($expense_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $expense_id when calling accountingExpensesUpdateExpense');
        }
        // verify the required parameter 'expense' is set
        if ($expense === null) {
            throw new \InvalidArgumentException('Missing the required parameter $expense when calling accountingExpensesUpdateExpense');
        }
        // verify the required parameter 'version' is set
        if ($version === null) {
            throw new \InvalidArgumentException('Missing the required parameter $version when calling accountingExpensesUpdateExpense');
        }
        // parse inputs
        $resourcePath = "/api/v{version}/accounting/{period}/expenses/{expenseId}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json', 'text/json', 'text/html']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json', 'text/json', 'text/html', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded']);

        // query params
        if ($bypass_invoice_duplicate_validation !== null) {
            $queryParams['bypassInvoiceDuplicateValidation'] = $this->apiClient->getSerializer()->toQueryValue($bypass_invoice_duplicate_validation);
        }
        // path params
        if ($period !== null) {
            $resourcePath = str_replace(
                "{" . "period" . "}",
                $this->apiClient->getSerializer()->toPathValue($period),
                $resourcePath
            );
        }
        // path params
        if ($expense_id !== null) {
            $resourcePath = str_replace(
                "{" . "expenseId" . "}",
                $this->apiClient->getSerializer()->toPathValue($expense_id),
                $resourcePath
            );
        }
        // path params
        if ($version !== null) {
            $resourcePath = str_replace(
                "{" . "version" . "}",
                $this->apiClient->getSerializer()->toPathValue($version),
                $resourcePath
            );
        }
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        // body params
        $_tempBody = null;
        if (isset($expense)) {
            $_tempBody = $expense;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PUT',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\ApiResultInt64',
                '/api/v{version}/accounting/{period}/expenses/{expenseId}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\ApiResultInt64', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\ApiResultInt64', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
