<?php
/**
 * ApiAccessApiModel
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * ApiAccessApiModel Class Doc Comment
 *
 * @category    Class */
 // @description Defines the information about a platofmr that have access to the user information
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ApiAccessApiModel implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ApiAccessApiModel';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'api_client' => '\Swagger\Client\Model\ApiClientApiModel',
        'is_active' => 'bool',
        'can_disable' => 'bool',
        'first_access_time' => '\DateTime',
        'last_access_time' => '\DateTime'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'api_client' => 'apiClient',
        'is_active' => 'isActive',
        'can_disable' => 'canDisable',
        'first_access_time' => 'firstAccessTime',
        'last_access_time' => 'lastAccessTime'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'api_client' => 'setApiClient',
        'is_active' => 'setIsActive',
        'can_disable' => 'setCanDisable',
        'first_access_time' => 'setFirstAccessTime',
        'last_access_time' => 'setLastAccessTime'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'api_client' => 'getApiClient',
        'is_active' => 'getIsActive',
        'can_disable' => 'getCanDisable',
        'first_access_time' => 'getFirstAccessTime',
        'last_access_time' => 'getLastAccessTime'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['api_client'] = isset($data['api_client']) ? $data['api_client'] : null;
        $this->container['is_active'] = isset($data['is_active']) ? $data['is_active'] : null;
        $this->container['can_disable'] = isset($data['can_disable']) ? $data['can_disable'] : null;
        $this->container['first_access_time'] = isset($data['first_access_time']) ? $data['first_access_time'] : null;
        $this->container['last_access_time'] = isset($data['last_access_time']) ? $data['last_access_time'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets api_client
     * @return \Swagger\Client\Model\ApiClientApiModel
     */
    public function getApiClient()
    {
        return $this->container['api_client'];
    }

    /**
     * Sets api_client
     * @param \Swagger\Client\Model\ApiClientApiModel $api_client API client information
     * @return $this
     */
    public function setApiClient($api_client)
    {
        $this->container['api_client'] = $api_client;

        return $this;
    }

    /**
     * Gets is_active
     * @return bool
     */
    public function getIsActive()
    {
        return $this->container['is_active'];
    }

    /**
     * Sets is_active
     * @param bool $is_active Indicates if the client access is valid or have been revoked
     * @return $this
     */
    public function setIsActive($is_active)
    {
        $this->container['is_active'] = $is_active;

        return $this;
    }

    /**
     * Gets can_disable
     * @return bool
     */
    public function getCanDisable()
    {
        return $this->container['can_disable'];
    }

    /**
     * Sets can_disable
     * @param bool $can_disable Indicates if the client can disable user access to the current API client
     * @return $this
     */
    public function setCanDisable($can_disable)
    {
        $this->container['can_disable'] = $can_disable;

        return $this;
    }

    /**
     * Gets first_access_time
     * @return \DateTime
     */
    public function getFirstAccessTime()
    {
        return $this->container['first_access_time'];
    }

    /**
     * Sets first_access_time
     * @param \DateTime $first_access_time The first time the client accessed the user account
     * @return $this
     */
    public function setFirstAccessTime($first_access_time)
    {
        $this->container['first_access_time'] = $first_access_time;

        return $this;
    }

    /**
     * Gets last_access_time
     * @return \DateTime
     */
    public function getLastAccessTime()
    {
        return $this->container['last_access_time'];
    }

    /**
     * Sets last_access_time
     * @param \DateTime $last_access_time The last time the client accessed the user account
     * @return $this
     */
    public function setLastAccessTime($last_access_time)
    {
        $this->container['last_access_time'] = $last_access_time;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
