<?php
/**
 * AppVersionApiModel
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * AppVersionApiModel Class Doc Comment
 *
 * @category    Class */
 // @description Defines the information of an app version
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class AppVersionApiModel implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'AppVersionApiModel';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'int',
        'name' => 'string',
        'app_identifier' => 'string',
        'platform' => 'string',
        'store_url' => 'string',
        'version_code' => 'int',
        'version_name' => 'string',
        'force_update' => 'bool',
        'create_time' => '\DateTime'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'name' => 'name',
        'app_identifier' => 'appIdentifier',
        'platform' => 'platform',
        'store_url' => 'storeUrl',
        'version_code' => 'versionCode',
        'version_name' => 'versionName',
        'force_update' => 'forceUpdate',
        'create_time' => 'createTime'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'name' => 'setName',
        'app_identifier' => 'setAppIdentifier',
        'platform' => 'setPlatform',
        'store_url' => 'setStoreUrl',
        'version_code' => 'setVersionCode',
        'version_name' => 'setVersionName',
        'force_update' => 'setForceUpdate',
        'create_time' => 'setCreateTime'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'name' => 'getName',
        'app_identifier' => 'getAppIdentifier',
        'platform' => 'getPlatform',
        'store_url' => 'getStoreUrl',
        'version_code' => 'getVersionCode',
        'version_name' => 'getVersionName',
        'force_update' => 'getForceUpdate',
        'create_time' => 'getCreateTime'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    const PLATFORM_ANDROID = 'Android';
    const PLATFORM_I_OS = 'iOS';
    

    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public function getPlatformAllowableValues()
    {
        return [
            self::PLATFORM_ANDROID,
            self::PLATFORM_I_OS,
        ];
    }
    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['app_identifier'] = isset($data['app_identifier']) ? $data['app_identifier'] : null;
        $this->container['platform'] = isset($data['platform']) ? $data['platform'] : null;
        $this->container['store_url'] = isset($data['store_url']) ? $data['store_url'] : null;
        $this->container['version_code'] = isset($data['version_code']) ? $data['version_code'] : null;
        $this->container['version_name'] = isset($data['version_name']) ? $data['version_name'] : null;
        $this->container['force_update'] = isset($data['force_update']) ? $data['force_update'] : null;
        $this->container['create_time'] = isset($data['create_time']) ? $data['create_time'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        $allowed_values = ["Android", "iOS"];
        if (!in_array($this->container['platform'], $allowed_values)) {
            $invalid_properties[] = "invalid value for 'platform', must be one of #{allowed_values}.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        $allowed_values = ["Android", "iOS"];
        if (!in_array($this->container['platform'], $allowed_values)) {
            return false;
        }
        return true;
    }


    /**
     * Gets id
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     * @param int $id The identifeir of the version
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name The app name (just a display name)
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets app_identifier
     * @return string
     */
    public function getAppIdentifier()
    {
        return $this->container['app_identifier'];
    }

    /**
     * Sets app_identifier
     * @param string $app_identifier The identifier (bundle Id or package name) of the app
     * @return $this
     */
    public function setAppIdentifier($app_identifier)
    {
        $this->container['app_identifier'] = $app_identifier;

        return $this;
    }

    /**
     * Gets platform
     * @return string
     */
    public function getPlatform()
    {
        return $this->container['platform'];
    }

    /**
     * Sets platform
     * @param string $platform The app platform
     * @return $this
     */
    public function setPlatform($platform)
    {
        $allowed_values = array('Android', 'iOS');
        if (!is_null($platform) && (!in_array($platform, $allowed_values))) {
            throw new \InvalidArgumentException("Invalid value for 'platform', must be one of 'Android', 'iOS'");
        }
        $this->container['platform'] = $platform;

        return $this;
    }

    /**
     * Gets store_url
     * @return string
     */
    public function getStoreUrl()
    {
        return $this->container['store_url'];
    }

    /**
     * Sets store_url
     * @param string $store_url The URL where to get the version from
     * @return $this
     */
    public function setStoreUrl($store_url)
    {
        $this->container['store_url'] = $store_url;

        return $this;
    }

    /**
     * Gets version_code
     * @return int
     */
    public function getVersionCode()
    {
        return $this->container['version_code'];
    }

    /**
     * Sets version_code
     * @param int $version_code The app version code
     * @return $this
     */
    public function setVersionCode($version_code)
    {
        $this->container['version_code'] = $version_code;

        return $this;
    }

    /**
     * Gets version_name
     * @return string
     */
    public function getVersionName()
    {
        return $this->container['version_name'];
    }

    /**
     * Sets version_name
     * @param string $version_name The app version name
     * @return $this
     */
    public function setVersionName($version_name)
    {
        $this->container['version_name'] = $version_name;

        return $this;
    }

    /**
     * Gets force_update
     * @return bool
     */
    public function getForceUpdate()
    {
        return $this->container['force_update'];
    }

    /**
     * Sets force_update
     * @param bool $force_update Indicates if it is a forced update
     * @return $this
     */
    public function setForceUpdate($force_update)
    {
        $this->container['force_update'] = $force_update;

        return $this;
    }

    /**
     * Gets create_time
     * @return \DateTime
     */
    public function getCreateTime()
    {
        return $this->container['create_time'];
    }

    /**
     * Sets create_time
     * @param \DateTime $create_time The time when teh version was created
     * @return $this
     */
    public function setCreateTime($create_time)
    {
        $this->container['create_time'] = $create_time;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
