<?php
/**
 * ClassItem
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * ClassItem Class Doc Comment
 *
 * @category    Class */
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ClassItem implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ClassItem';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'account_group' => 'int',
        'account_number' => 'string',
        'description_prefix' => 'string',
        'description' => 'string',
        'enabled' => 'bool',
        'sub_items' => '\Swagger\Client\Model\ClassItem[]',
        'name' => 'string',
        'class_item_type' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'account_group' => 'accountGroup',
        'account_number' => 'accountNumber',
        'description_prefix' => 'descriptionPrefix',
        'description' => 'description',
        'enabled' => 'enabled',
        'sub_items' => 'subItems',
        'name' => 'name',
        'class_item_type' => 'classItemType'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'account_group' => 'setAccountGroup',
        'account_number' => 'setAccountNumber',
        'description_prefix' => 'setDescriptionPrefix',
        'description' => 'setDescription',
        'enabled' => 'setEnabled',
        'sub_items' => 'setSubItems',
        'name' => 'setName',
        'class_item_type' => 'setClassItemType'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'account_group' => 'getAccountGroup',
        'account_number' => 'getAccountNumber',
        'description_prefix' => 'getDescriptionPrefix',
        'description' => 'getDescription',
        'enabled' => 'getEnabled',
        'sub_items' => 'getSubItems',
        'name' => 'getName',
        'class_item_type' => 'getClassItemType'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    const CLASS_ITEM_TYPE_GOODS = 'Goods';
    const CLASS_ITEM_TYPE_SERVICES = 'Services';
    

    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public function getClassItemTypeAllowableValues()
    {
        return [
            self::CLASS_ITEM_TYPE_GOODS,
            self::CLASS_ITEM_TYPE_SERVICES,
        ];
    }
    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['account_group'] = isset($data['account_group']) ? $data['account_group'] : null;
        $this->container['account_number'] = isset($data['account_number']) ? $data['account_number'] : null;
        $this->container['description_prefix'] = isset($data['description_prefix']) ? $data['description_prefix'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['enabled'] = isset($data['enabled']) ? $data['enabled'] : null;
        $this->container['sub_items'] = isset($data['sub_items']) ? $data['sub_items'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['class_item_type'] = isset($data['class_item_type']) ? $data['class_item_type'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        $allowed_values = ["Goods", "Services"];
        if (!in_array($this->container['class_item_type'], $allowed_values)) {
            $invalid_properties[] = "invalid value for 'class_item_type', must be one of #{allowed_values}.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        $allowed_values = ["Goods", "Services"];
        if (!in_array($this->container['class_item_type'], $allowed_values)) {
            return false;
        }
        return true;
    }


    /**
     * Gets account_group
     * @return int
     */
    public function getAccountGroup()
    {
        return $this->container['account_group'];
    }

    /**
     * Sets account_group
     * @param int $account_group
     * @return $this
     */
    public function setAccountGroup($account_group)
    {
        $this->container['account_group'] = $account_group;

        return $this;
    }

    /**
     * Gets account_number
     * @return string
     */
    public function getAccountNumber()
    {
        return $this->container['account_number'];
    }

    /**
     * Sets account_number
     * @param string $account_number
     * @return $this
     */
    public function setAccountNumber($account_number)
    {
        $this->container['account_number'] = $account_number;

        return $this;
    }

    /**
     * Gets description_prefix
     * @return string
     */
    public function getDescriptionPrefix()
    {
        return $this->container['description_prefix'];
    }

    /**
     * Sets description_prefix
     * @param string $description_prefix
     * @return $this
     */
    public function setDescriptionPrefix($description_prefix)
    {
        $this->container['description_prefix'] = $description_prefix;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets enabled
     * @return bool
     */
    public function getEnabled()
    {
        return $this->container['enabled'];
    }

    /**
     * Sets enabled
     * @param bool $enabled
     * @return $this
     */
    public function setEnabled($enabled)
    {
        $this->container['enabled'] = $enabled;

        return $this;
    }

    /**
     * Gets sub_items
     * @return \Swagger\Client\Model\ClassItem[]
     */
    public function getSubItems()
    {
        return $this->container['sub_items'];
    }

    /**
     * Sets sub_items
     * @param \Swagger\Client\Model\ClassItem[] $sub_items
     * @return $this
     */
    public function setSubItems($sub_items)
    {
        $this->container['sub_items'] = $sub_items;

        return $this;
    }

    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     * @param string $name
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets class_item_type
     * @return string
     */
    public function getClassItemType()
    {
        return $this->container['class_item_type'];
    }

    /**
     * Sets class_item_type
     * @param string $class_item_type
     * @return $this
     */
    public function setClassItemType($class_item_type)
    {
        $allowed_values = array('Goods', 'Services');
        if (!is_null($class_item_type) && (!in_array($class_item_type, $allowed_values))) {
            throw new \InvalidArgumentException("Invalid value for 'class_item_type', must be one of 'Goods', 'Services'");
        }
        $this->container['class_item_type'] = $class_item_type;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
