<?php
/**
 * ConfigurationApiModel
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * ConfigurationApiModel Class Doc Comment
 *
 * @category    Class */
 // @description Contains all the platform configuration options
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ConfigurationApiModel implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ConfigurationApiModel';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'countries' => '\Swagger\Client\Model\CountryApiModel[]',
        'company_types' => '\Swagger\Client\Model\CompanyTypeApiModel[]',
        'irpf_estimation_modes' => '\Swagger\Client\Model\IrpfModeApiModel[]',
        'vat_modes' => '\Swagger\Client\Model\VatModeApiModel[]',
        'issued_invoices_classes' => '\Swagger\Client\Model\ClassItem[]',
        'received_invoices_classes' => '\Swagger\Client\Model\ClassItem[]'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'countries' => 'countries',
        'company_types' => 'companyTypes',
        'irpf_estimation_modes' => 'irpfEstimationModes',
        'vat_modes' => 'vatModes',
        'issued_invoices_classes' => 'issuedInvoicesClasses',
        'received_invoices_classes' => 'receivedInvoicesClasses'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'countries' => 'setCountries',
        'company_types' => 'setCompanyTypes',
        'irpf_estimation_modes' => 'setIrpfEstimationModes',
        'vat_modes' => 'setVatModes',
        'issued_invoices_classes' => 'setIssuedInvoicesClasses',
        'received_invoices_classes' => 'setReceivedInvoicesClasses'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'countries' => 'getCountries',
        'company_types' => 'getCompanyTypes',
        'irpf_estimation_modes' => 'getIrpfEstimationModes',
        'vat_modes' => 'getVatModes',
        'issued_invoices_classes' => 'getIssuedInvoicesClasses',
        'received_invoices_classes' => 'getReceivedInvoicesClasses'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['countries'] = isset($data['countries']) ? $data['countries'] : null;
        $this->container['company_types'] = isset($data['company_types']) ? $data['company_types'] : null;
        $this->container['irpf_estimation_modes'] = isset($data['irpf_estimation_modes']) ? $data['irpf_estimation_modes'] : null;
        $this->container['vat_modes'] = isset($data['vat_modes']) ? $data['vat_modes'] : null;
        $this->container['issued_invoices_classes'] = isset($data['issued_invoices_classes']) ? $data['issued_invoices_classes'] : null;
        $this->container['received_invoices_classes'] = isset($data['received_invoices_classes']) ? $data['received_invoices_classes'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets countries
     * @return \Swagger\Client\Model\CountryApiModel[]
     */
    public function getCountries()
    {
        return $this->container['countries'];
    }

    /**
     * Sets countries
     * @param \Swagger\Client\Model\CountryApiModel[] $countries Countries configuration
     * @return $this
     */
    public function setCountries($countries)
    {
        $this->container['countries'] = $countries;

        return $this;
    }

    /**
     * Gets company_types
     * @return \Swagger\Client\Model\CompanyTypeApiModel[]
     */
    public function getCompanyTypes()
    {
        return $this->container['company_types'];
    }

    /**
     * Sets company_types
     * @param \Swagger\Client\Model\CompanyTypeApiModel[] $company_types Company types configuration
     * @return $this
     */
    public function setCompanyTypes($company_types)
    {
        $this->container['company_types'] = $company_types;

        return $this;
    }

    /**
     * Gets irpf_estimation_modes
     * @return \Swagger\Client\Model\IrpfModeApiModel[]
     */
    public function getIrpfEstimationModes()
    {
        return $this->container['irpf_estimation_modes'];
    }

    /**
     * Sets irpf_estimation_modes
     * @param \Swagger\Client\Model\IrpfModeApiModel[] $irpf_estimation_modes IRPF estimation modes
     * @return $this
     */
    public function setIrpfEstimationModes($irpf_estimation_modes)
    {
        $this->container['irpf_estimation_modes'] = $irpf_estimation_modes;

        return $this;
    }

    /**
     * Gets vat_modes
     * @return \Swagger\Client\Model\VatModeApiModel[]
     */
    public function getVatModes()
    {
        return $this->container['vat_modes'];
    }

    /**
     * Sets vat_modes
     * @param \Swagger\Client\Model\VatModeApiModel[] $vat_modes VAT modes
     * @return $this
     */
    public function setVatModes($vat_modes)
    {
        $this->container['vat_modes'] = $vat_modes;

        return $this;
    }

    /**
     * Gets issued_invoices_classes
     * @return \Swagger\Client\Model\ClassItem[]
     */
    public function getIssuedInvoicesClasses()
    {
        return $this->container['issued_invoices_classes'];
    }

    /**
     * Sets issued_invoices_classes
     * @param \Swagger\Client\Model\ClassItem[] $issued_invoices_classes The list of invoice types for the issued invoices
     * @return $this
     */
    public function setIssuedInvoicesClasses($issued_invoices_classes)
    {
        $this->container['issued_invoices_classes'] = $issued_invoices_classes;

        return $this;
    }

    /**
     * Gets received_invoices_classes
     * @return \Swagger\Client\Model\ClassItem[]
     */
    public function getReceivedInvoicesClasses()
    {
        return $this->container['received_invoices_classes'];
    }

    /**
     * Sets received_invoices_classes
     * @param \Swagger\Client\Model\ClassItem[] $received_invoices_classes The list of invoice types for received invoices
     * @return $this
     */
    public function setReceivedInvoicesClasses($received_invoices_classes)
    {
        $this->container['received_invoices_classes'] = $received_invoices_classes;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
