<?php
/**
 * FileApiModel
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * FileApiModel Class Doc Comment
 *
 * @category    Class */
 // @description Defines the information for a file or folder
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class FileApiModel implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'FileApiModel';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'int',
        'filename' => 'string',
        'extension' => 'string',
        'parent_id' => 'int',
        'type' => 'string',
        'size' => 'int',
        'date' => '\DateTime',
        'description' => 'string',
        'code' => 'string',
        'display_full_filename' => 'string',
        'dependency_type' => 'string',
        'dependency_sub_type' => 'string',
        'dependency_number' => 'string',
        'dependency_id' => 'int'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'filename' => 'filename',
        'extension' => 'extension',
        'parent_id' => 'parentId',
        'type' => 'type',
        'size' => 'size',
        'date' => 'date',
        'description' => 'description',
        'code' => 'code',
        'display_full_filename' => 'displayFullFilename',
        'dependency_type' => 'dependencyType',
        'dependency_sub_type' => 'dependencySubType',
        'dependency_number' => 'dependencyNumber',
        'dependency_id' => 'dependencyId'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'filename' => 'setFilename',
        'extension' => 'setExtension',
        'parent_id' => 'setParentId',
        'type' => 'setType',
        'size' => 'setSize',
        'date' => 'setDate',
        'description' => 'setDescription',
        'code' => 'setCode',
        'display_full_filename' => 'setDisplayFullFilename',
        'dependency_type' => 'setDependencyType',
        'dependency_sub_type' => 'setDependencySubType',
        'dependency_number' => 'setDependencyNumber',
        'dependency_id' => 'setDependencyId'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'filename' => 'getFilename',
        'extension' => 'getExtension',
        'parent_id' => 'getParentId',
        'type' => 'getType',
        'size' => 'getSize',
        'date' => 'getDate',
        'description' => 'getDescription',
        'code' => 'getCode',
        'display_full_filename' => 'getDisplayFullFilename',
        'dependency_type' => 'getDependencyType',
        'dependency_sub_type' => 'getDependencySubType',
        'dependency_number' => 'getDependencyNumber',
        'dependency_id' => 'getDependencyId'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    const TYPE_FILE = 'File';
    const TYPE_FOLDER = 'Folder';
    const DEPENDENCY_TYPE_NONE = 'None';
    const DEPENDENCY_TYPE_INVOICE = 'Invoice';
    const DEPENDENCY_TYPE_EXPENSE = 'Expense';
    const DEPENDENCY_TYPE_DELIVERY_NOTE = 'DeliveryNote';
    const DEPENDENCY_TYPE_PRESUPUESTO = 'Presupuesto';
    const DEPENDENCY_TYPE_ENTITY = 'Entity';
    const DEPENDENCY_TYPE_DOMICILIACION = 'Domiciliacion';
    const DEPENDENCY_TYPE_EXPORT = 'Export';
    const DEPENDENCY_TYPE_EXPORT_INVOICES = 'ExportInvoices';
    const DEPENDENCY_TYPE_EXPORT_A3 = 'ExportA3';
    const DEPENDENCY_TYPE_EXPORT_IVA = 'ExportIVA';
    const DEPENDENCY_TYPE_EXPORT_IRPF = 'ExportIRPF';
    const DEPENDENCY_TYPE_EXPORT_ADVANCED = 'ExportAdvanced';
    const DEPENDENCY_TYPE_ALL = 'All';
    

    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public function getTypeAllowableValues()
    {
        return [
            self::TYPE_FILE,
            self::TYPE_FOLDER,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public function getDependencyTypeAllowableValues()
    {
        return [
            self::DEPENDENCY_TYPE_NONE,
            self::DEPENDENCY_TYPE_INVOICE,
            self::DEPENDENCY_TYPE_EXPENSE,
            self::DEPENDENCY_TYPE_DELIVERY_NOTE,
            self::DEPENDENCY_TYPE_PRESUPUESTO,
            self::DEPENDENCY_TYPE_ENTITY,
            self::DEPENDENCY_TYPE_DOMICILIACION,
            self::DEPENDENCY_TYPE_EXPORT,
            self::DEPENDENCY_TYPE_EXPORT_INVOICES,
            self::DEPENDENCY_TYPE_EXPORT_A3,
            self::DEPENDENCY_TYPE_EXPORT_IVA,
            self::DEPENDENCY_TYPE_EXPORT_IRPF,
            self::DEPENDENCY_TYPE_EXPORT_ADVANCED,
            self::DEPENDENCY_TYPE_ALL,
        ];
    }
    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['filename'] = isset($data['filename']) ? $data['filename'] : null;
        $this->container['extension'] = isset($data['extension']) ? $data['extension'] : null;
        $this->container['parent_id'] = isset($data['parent_id']) ? $data['parent_id'] : null;
        $this->container['type'] = isset($data['type']) ? $data['type'] : null;
        $this->container['size'] = isset($data['size']) ? $data['size'] : null;
        $this->container['date'] = isset($data['date']) ? $data['date'] : null;
        $this->container['description'] = isset($data['description']) ? $data['description'] : null;
        $this->container['code'] = isset($data['code']) ? $data['code'] : null;
        $this->container['display_full_filename'] = isset($data['display_full_filename']) ? $data['display_full_filename'] : null;
        $this->container['dependency_type'] = isset($data['dependency_type']) ? $data['dependency_type'] : null;
        $this->container['dependency_sub_type'] = isset($data['dependency_sub_type']) ? $data['dependency_sub_type'] : null;
        $this->container['dependency_number'] = isset($data['dependency_number']) ? $data['dependency_number'] : null;
        $this->container['dependency_id'] = isset($data['dependency_id']) ? $data['dependency_id'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        $allowed_values = ["File", "Folder"];
        if (!in_array($this->container['type'], $allowed_values)) {
            $invalid_properties[] = "invalid value for 'type', must be one of #{allowed_values}.";
        }

        $allowed_values = ["None", "Invoice", "Expense", "DeliveryNote", "Presupuesto", "Entity", "Domiciliacion", "Export", "ExportInvoices", "ExportA3", "ExportIVA", "ExportIRPF", "ExportAdvanced", "All"];
        if (!in_array($this->container['dependency_type'], $allowed_values)) {
            $invalid_properties[] = "invalid value for 'dependency_type', must be one of #{allowed_values}.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        $allowed_values = ["File", "Folder"];
        if (!in_array($this->container['type'], $allowed_values)) {
            return false;
        }
        $allowed_values = ["None", "Invoice", "Expense", "DeliveryNote", "Presupuesto", "Entity", "Domiciliacion", "Export", "ExportInvoices", "ExportA3", "ExportIVA", "ExportIRPF", "ExportAdvanced", "All"];
        if (!in_array($this->container['dependency_type'], $allowed_values)) {
            return false;
        }
        return true;
    }


    /**
     * Gets id
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     * @param int $id The identifier of the file ofr folder
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets filename
     * @return string
     */
    public function getFilename()
    {
        return $this->container['filename'];
    }

    /**
     * Sets filename
     * @param string $filename The name of the file or folder
     * @return $this
     */
    public function setFilename($filename)
    {
        $this->container['filename'] = $filename;

        return $this;
    }

    /**
     * Gets extension
     * @return string
     */
    public function getExtension()
    {
        return $this->container['extension'];
    }

    /**
     * Sets extension
     * @param string $extension The extension of the file
     * @return $this
     */
    public function setExtension($extension)
    {
        $this->container['extension'] = $extension;

        return $this;
    }

    /**
     * Gets parent_id
     * @return int
     */
    public function getParentId()
    {
        return $this->container['parent_id'];
    }

    /**
     * Sets parent_id
     * @param int $parent_id The parent folder (if exists)
     * @return $this
     */
    public function setParentId($parent_id)
    {
        $this->container['parent_id'] = $parent_id;

        return $this;
    }

    /**
     * Gets type
     * @return string
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     * @param string $type The type of element
     * @return $this
     */
    public function setType($type)
    {
        $allowed_values = array('File', 'Folder');
        if (!is_null($type) && (!in_array($type, $allowed_values))) {
            throw new \InvalidArgumentException("Invalid value for 'type', must be one of 'File', 'Folder'");
        }
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets size
     * @return int
     */
    public function getSize()
    {
        return $this->container['size'];
    }

    /**
     * Sets size
     * @param int $size The size of the file
     * @return $this
     */
    public function setSize($size)
    {
        $this->container['size'] = $size;

        return $this;
    }

    /**
     * Gets date
     * @return \DateTime
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     * @param \DateTime $date The file update time
     * @return $this
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     * @param string $description The file or folder description
     * @return $this
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets code
     * @return string
     */
    public function getCode()
    {
        return $this->container['code'];
    }

    /**
     * Sets code
     * @param string $code The code for the vitrual folders
     * @return $this
     */
    public function setCode($code)
    {
        $this->container['code'] = $code;

        return $this;
    }

    /**
     * Gets display_full_filename
     * @return string
     */
    public function getDisplayFullFilename()
    {
        return $this->container['display_full_filename'];
    }

    /**
     * Sets display_full_filename
     * @param string $display_full_filename The full display name
     * @return $this
     */
    public function setDisplayFullFilename($display_full_filename)
    {
        $this->container['display_full_filename'] = $display_full_filename;

        return $this;
    }

    /**
     * Gets dependency_type
     * @return string
     */
    public function getDependencyType()
    {
        return $this->container['dependency_type'];
    }

    /**
     * Sets dependency_type
     * @param string $dependency_type The type of dependency
     * @return $this
     */
    public function setDependencyType($dependency_type)
    {
        $allowed_values = array('None', 'Invoice', 'Expense', 'DeliveryNote', 'Presupuesto', 'Entity', 'Domiciliacion', 'Export', 'ExportInvoices', 'ExportA3', 'ExportIVA', 'ExportIRPF', 'ExportAdvanced', 'All');
        if (!is_null($dependency_type) && (!in_array($dependency_type, $allowed_values))) {
            throw new \InvalidArgumentException("Invalid value for 'dependency_type', must be one of 'None', 'Invoice', 'Expense', 'DeliveryNote', 'Presupuesto', 'Entity', 'Domiciliacion', 'Export', 'ExportInvoices', 'ExportA3', 'ExportIVA', 'ExportIRPF', 'ExportAdvanced', 'All'");
        }
        $this->container['dependency_type'] = $dependency_type;

        return $this;
    }

    /**
     * Gets dependency_sub_type
     * @return string
     */
    public function getDependencySubType()
    {
        return $this->container['dependency_sub_type'];
    }

    /**
     * Sets dependency_sub_type
     * @param string $dependency_sub_type THe dependency subtype
     * @return $this
     */
    public function setDependencySubType($dependency_sub_type)
    {
        $this->container['dependency_sub_type'] = $dependency_sub_type;

        return $this;
    }

    /**
     * Gets dependency_number
     * @return string
     */
    public function getDependencyNumber()
    {
        return $this->container['dependency_number'];
    }

    /**
     * Sets dependency_number
     * @param string $dependency_number The number of the dependency element
     * @return $this
     */
    public function setDependencyNumber($dependency_number)
    {
        $this->container['dependency_number'] = $dependency_number;

        return $this;
    }

    /**
     * Gets dependency_id
     * @return int
     */
    public function getDependencyId()
    {
        return $this->container['dependency_id'];
    }

    /**
     * Sets dependency_id
     * @param int $dependency_id The identifier of teh dependency element
     * @return $this
     */
    public function setDependencyId($dependency_id)
    {
        $this->container['dependency_id'] = $dependency_id;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
