<?php
/**
 * InvoiceLineRequestApiModel
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * InvoiceLineRequestApiModel Class Doc Comment
 *
 * @category    Class */
 // @description Contains the information for an invoice line
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class InvoiceLineRequestApiModel implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'InvoiceLineRequestApiModel';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'concept' => 'string',
        'unit_amount' => 'double',
        'quantity' => 'double',
        'vat_percentage' => 'double',
        'vat_amount' => 'double',
        're_percentage' => 'double',
        're_amount' => 'double',
        'total_taxable_amount' => 'double'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'concept' => 'concept',
        'unit_amount' => 'unitAmount',
        'quantity' => 'quantity',
        'vat_percentage' => 'vatPercentage',
        'vat_amount' => 'vatAmount',
        're_percentage' => 'rePercentage',
        're_amount' => 'reAmount',
        'total_taxable_amount' => 'totalTaxableAmount'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'concept' => 'setConcept',
        'unit_amount' => 'setUnitAmount',
        'quantity' => 'setQuantity',
        'vat_percentage' => 'setVatPercentage',
        'vat_amount' => 'setVatAmount',
        're_percentage' => 'setRePercentage',
        're_amount' => 'setReAmount',
        'total_taxable_amount' => 'setTotalTaxableAmount'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'concept' => 'getConcept',
        'unit_amount' => 'getUnitAmount',
        'quantity' => 'getQuantity',
        'vat_percentage' => 'getVatPercentage',
        'vat_amount' => 'getVatAmount',
        're_percentage' => 'getRePercentage',
        're_amount' => 'getReAmount',
        'total_taxable_amount' => 'getTotalTaxableAmount'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['concept'] = isset($data['concept']) ? $data['concept'] : null;
        $this->container['unit_amount'] = isset($data['unit_amount']) ? $data['unit_amount'] : null;
        $this->container['quantity'] = isset($data['quantity']) ? $data['quantity'] : null;
        $this->container['vat_percentage'] = isset($data['vat_percentage']) ? $data['vat_percentage'] : null;
        $this->container['vat_amount'] = isset($data['vat_amount']) ? $data['vat_amount'] : null;
        $this->container['re_percentage'] = isset($data['re_percentage']) ? $data['re_percentage'] : null;
        $this->container['re_amount'] = isset($data['re_amount']) ? $data['re_amount'] : null;
        $this->container['total_taxable_amount'] = isset($data['total_taxable_amount']) ? $data['total_taxable_amount'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if ($this->container['concept'] === null) {
            $invalid_properties[] = "'concept' can't be null";
        }
        if ($this->container['unit_amount'] === null) {
            $invalid_properties[] = "'unit_amount' can't be null";
        }
        if ($this->container['quantity'] === null) {
            $invalid_properties[] = "'quantity' can't be null";
        }
        if (($this->container['quantity'] > 2.147483647E9)) {
            $invalid_properties[] = "invalid value for 'quantity', must be smaller than or equal to 2.147483647E9.";
        }

        if (($this->container['quantity'] < 0.0)) {
            $invalid_properties[] = "invalid value for 'quantity', must be bigger than or equal to 0.0.";
        }

        if ($this->container['vat_percentage'] === null) {
            $invalid_properties[] = "'vat_percentage' can't be null";
        }
        if (($this->container['vat_percentage'] > 100.0)) {
            $invalid_properties[] = "invalid value for 'vat_percentage', must be smaller than or equal to 100.0.";
        }

        if (($this->container['vat_percentage'] < 0.0)) {
            $invalid_properties[] = "invalid value for 'vat_percentage', must be bigger than or equal to 0.0.";
        }

        if ($this->container['vat_amount'] === null) {
            $invalid_properties[] = "'vat_amount' can't be null";
        }
        if (!is_null($this->container['re_percentage']) && ($this->container['re_percentage'] > 100.0)) {
            $invalid_properties[] = "invalid value for 're_percentage', must be smaller than or equal to 100.0.";
        }

        if (!is_null($this->container['re_percentage']) && ($this->container['re_percentage'] < 0.0)) {
            $invalid_properties[] = "invalid value for 're_percentage', must be bigger than or equal to 0.0.";
        }

        if ($this->container['total_taxable_amount'] === null) {
            $invalid_properties[] = "'total_taxable_amount' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        if ($this->container['concept'] === null) {
            return false;
        }
        if ($this->container['unit_amount'] === null) {
            return false;
        }
        if ($this->container['quantity'] === null) {
            return false;
        }
        if ($this->container['quantity'] > 2.147483647E9) {
            return false;
        }
        if ($this->container['quantity'] < 0.0) {
            return false;
        }
        if ($this->container['vat_percentage'] === null) {
            return false;
        }
        if ($this->container['vat_percentage'] > 100.0) {
            return false;
        }
        if ($this->container['vat_percentage'] < 0.0) {
            return false;
        }
        if ($this->container['vat_amount'] === null) {
            return false;
        }
        if ($this->container['re_percentage'] > 100.0) {
            return false;
        }
        if ($this->container['re_percentage'] < 0.0) {
            return false;
        }
        if ($this->container['total_taxable_amount'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets concept
     * @return string
     */
    public function getConcept()
    {
        return $this->container['concept'];
    }

    /**
     * Sets concept
     * @param string $concept The invoice line concept
     * @return $this
     */
    public function setConcept($concept)
    {
        $this->container['concept'] = $concept;

        return $this;
    }

    /**
     * Gets unit_amount
     * @return double
     */
    public function getUnitAmount()
    {
        return $this->container['unit_amount'];
    }

    /**
     * Sets unit_amount
     * @param double $unit_amount The invoice line unit base amount  There is a limit of two decimals.
     * @return $this
     */
    public function setUnitAmount($unit_amount)
    {
        $this->container['unit_amount'] = $unit_amount;

        return $this;
    }

    /**
     * Gets quantity
     * @return double
     */
    public function getQuantity()
    {
        return $this->container['quantity'];
    }

    /**
     * Sets quantity
     * @param double $quantity The quantity of items on the invoice line
     * @return $this
     */
    public function setQuantity($quantity)
    {

        if (($quantity > 2.147483647E9)) {
            throw new \InvalidArgumentException('invalid value for $quantity when calling InvoiceLineRequestApiModel., must be smaller than or equal to 2.147483647E9.');
        }
        if (($quantity < 0.0)) {
            throw new \InvalidArgumentException('invalid value for $quantity when calling InvoiceLineRequestApiModel., must be bigger than or equal to 0.0.');
        }

        $this->container['quantity'] = $quantity;

        return $this;
    }

    /**
     * Gets vat_percentage
     * @return double
     */
    public function getVatPercentage()
    {
        return $this->container['vat_percentage'];
    }

    /**
     * Sets vat_percentage
     * @param double $vat_percentage The VAT percentage to apply to the invoice line
     * @return $this
     */
    public function setVatPercentage($vat_percentage)
    {

        if (($vat_percentage > 100.0)) {
            throw new \InvalidArgumentException('invalid value for $vat_percentage when calling InvoiceLineRequestApiModel., must be smaller than or equal to 100.0.');
        }
        if (($vat_percentage < 0.0)) {
            throw new \InvalidArgumentException('invalid value for $vat_percentage when calling InvoiceLineRequestApiModel., must be bigger than or equal to 0.0.');
        }

        $this->container['vat_percentage'] = $vat_percentage;

        return $this;
    }

    /**
     * Gets vat_amount
     * @return double
     */
    public function getVatAmount()
    {
        return $this->container['vat_amount'];
    }

    /**
     * Sets vat_amount
     * @param double $vat_amount The VAT amount of the invoice line  There is a limit of two decimals.
     * @return $this
     */
    public function setVatAmount($vat_amount)
    {
        $this->container['vat_amount'] = $vat_amount;

        return $this;
    }

    /**
     * Gets re_percentage
     * @return double
     */
    public function getRePercentage()
    {
        return $this->container['re_percentage'];
    }

    /**
     * Sets re_percentage
     * @param double $re_percentage The RE percentage to apply to the invoice line
     * @return $this
     */
    public function setRePercentage($re_percentage)
    {

        if (!is_null($re_percentage) && ($re_percentage > 100.0)) {
            throw new \InvalidArgumentException('invalid value for $re_percentage when calling InvoiceLineRequestApiModel., must be smaller than or equal to 100.0.');
        }
        if (!is_null($re_percentage) && ($re_percentage < 0.0)) {
            throw new \InvalidArgumentException('invalid value for $re_percentage when calling InvoiceLineRequestApiModel., must be bigger than or equal to 0.0.');
        }

        $this->container['re_percentage'] = $re_percentage;

        return $this;
    }

    /**
     * Gets re_amount
     * @return double
     */
    public function getReAmount()
    {
        return $this->container['re_amount'];
    }

    /**
     * Sets re_amount
     * @param double $re_amount The RE amount of the invoice line  There is a limit of two decimals.
     * @return $this
     */
    public function setReAmount($re_amount)
    {
        $this->container['re_amount'] = $re_amount;

        return $this;
    }

    /**
     * Gets total_taxable_amount
     * @return double
     */
    public function getTotalTaxableAmount()
    {
        return $this->container['total_taxable_amount'];
    }

    /**
     * Sets total_taxable_amount
     * @param double $total_taxable_amount The total taxable amount of the line.  There is a limit of two decimals.  This value is required to show the same rounded value applied by the client on the PDF.
     * @return $this
     */
    public function setTotalTaxableAmount($total_taxable_amount)
    {
        $this->container['total_taxable_amount'] = $total_taxable_amount;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
