<?php
/**
 * PublicInvoiceApiModel
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * PublicInvoiceApiModel Class Doc Comment
 *
 * @category    Class */
 // @description Defines the information for generating a public invoice
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class PublicInvoiceApiModel implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'PublicInvoiceApiModel';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'options' => '\Swagger\Client\Model\PublicInvoiceSharingOptionsApiModel',
        'logo' => 'string',
        'number' => 'string',
        'invoice_date' => '\DateTime',
        'expiration_date' => '\DateTime',
        'retention_percentage' => 'double',
        'footer' => 'string',
        'me' => '\Swagger\Client\Model\PublicInvoiceEntityApiModel',
        'target' => '\Swagger\Client\Model\PublicInvoiceEntityApiModel',
        'lines' => '\Swagger\Client\Model\PublicInvoiceLineApiModel[]',
        'configuration' => '\Swagger\Client\Model\PublicInvoiceConfigurationApiModel'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'options' => 'options',
        'logo' => 'logo',
        'number' => 'number',
        'invoice_date' => 'invoiceDate',
        'expiration_date' => 'expirationDate',
        'retention_percentage' => 'retentionPercentage',
        'footer' => 'footer',
        'me' => 'me',
        'target' => 'target',
        'lines' => 'lines',
        'configuration' => 'configuration'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'options' => 'setOptions',
        'logo' => 'setLogo',
        'number' => 'setNumber',
        'invoice_date' => 'setInvoiceDate',
        'expiration_date' => 'setExpirationDate',
        'retention_percentage' => 'setRetentionPercentage',
        'footer' => 'setFooter',
        'me' => 'setMe',
        'target' => 'setTarget',
        'lines' => 'setLines',
        'configuration' => 'setConfiguration'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'options' => 'getOptions',
        'logo' => 'getLogo',
        'number' => 'getNumber',
        'invoice_date' => 'getInvoiceDate',
        'expiration_date' => 'getExpirationDate',
        'retention_percentage' => 'getRetentionPercentage',
        'footer' => 'getFooter',
        'me' => 'getMe',
        'target' => 'getTarget',
        'lines' => 'getLines',
        'configuration' => 'getConfiguration'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['options'] = isset($data['options']) ? $data['options'] : null;
        $this->container['logo'] = isset($data['logo']) ? $data['logo'] : null;
        $this->container['number'] = isset($data['number']) ? $data['number'] : null;
        $this->container['invoice_date'] = isset($data['invoice_date']) ? $data['invoice_date'] : null;
        $this->container['expiration_date'] = isset($data['expiration_date']) ? $data['expiration_date'] : null;
        $this->container['retention_percentage'] = isset($data['retention_percentage']) ? $data['retention_percentage'] : null;
        $this->container['footer'] = isset($data['footer']) ? $data['footer'] : null;
        $this->container['me'] = isset($data['me']) ? $data['me'] : null;
        $this->container['target'] = isset($data['target']) ? $data['target'] : null;
        $this->container['lines'] = isset($data['lines']) ? $data['lines'] : null;
        $this->container['configuration'] = isset($data['configuration']) ? $data['configuration'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if ($this->container['options'] === null) {
            $invalid_properties[] = "'options' can't be null";
        }
        if ($this->container['number'] === null) {
            $invalid_properties[] = "'number' can't be null";
        }
        if ($this->container['invoice_date'] === null) {
            $invalid_properties[] = "'invoice_date' can't be null";
        }
        if (!is_null($this->container['retention_percentage']) && ($this->container['retention_percentage'] > 100.0)) {
            $invalid_properties[] = "invalid value for 'retention_percentage', must be smaller than or equal to 100.0.";
        }

        if (!is_null($this->container['retention_percentage']) && ($this->container['retention_percentage'] < 0.0)) {
            $invalid_properties[] = "invalid value for 'retention_percentage', must be bigger than or equal to 0.0.";
        }

        if ($this->container['me'] === null) {
            $invalid_properties[] = "'me' can't be null";
        }
        if ($this->container['target'] === null) {
            $invalid_properties[] = "'target' can't be null";
        }
        if ($this->container['lines'] === null) {
            $invalid_properties[] = "'lines' can't be null";
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        if ($this->container['options'] === null) {
            return false;
        }
        if ($this->container['number'] === null) {
            return false;
        }
        if ($this->container['invoice_date'] === null) {
            return false;
        }
        if ($this->container['retention_percentage'] > 100.0) {
            return false;
        }
        if ($this->container['retention_percentage'] < 0.0) {
            return false;
        }
        if ($this->container['me'] === null) {
            return false;
        }
        if ($this->container['target'] === null) {
            return false;
        }
        if ($this->container['lines'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets options
     * @return \Swagger\Client\Model\PublicInvoiceSharingOptionsApiModel
     */
    public function getOptions()
    {
        return $this->container['options'];
    }

    /**
     * Sets options
     * @param \Swagger\Client\Model\PublicInvoiceSharingOptionsApiModel $options Invoice generation options download the document or false to send it by email to the information setted on \"me\"/\"email\" field
     * @return $this
     */
    public function setOptions($options)
    {
        $this->container['options'] = $options;

        return $this;
    }

    /**
     * Gets logo
     * @return string
     */
    public function getLogo()
    {
        return $this->container['logo'];
    }

    /**
     * Sets logo
     * @param string $logo The logo token to display on the invoice. Must be uploaded previously using the \"/public/invoice/logo\" service.
     * @return $this
     */
    public function setLogo($logo)
    {
        $this->container['logo'] = $logo;

        return $this;
    }

    /**
     * Gets number
     * @return string
     */
    public function getNumber()
    {
        return $this->container['number'];
    }

    /**
     * Sets number
     * @param string $number The invoice number
     * @return $this
     */
    public function setNumber($number)
    {
        $this->container['number'] = $number;

        return $this;
    }

    /**
     * Gets invoice_date
     * @return \DateTime
     */
    public function getInvoiceDate()
    {
        return $this->container['invoice_date'];
    }

    /**
     * Sets invoice_date
     * @param \DateTime $invoice_date The invoice date
     * @return $this
     */
    public function setInvoiceDate($invoice_date)
    {
        $this->container['invoice_date'] = $invoice_date;

        return $this;
    }

    /**
     * Gets expiration_date
     * @return \DateTime
     */
    public function getExpirationDate()
    {
        return $this->container['expiration_date'];
    }

    /**
     * Sets expiration_date
     * @param \DateTime $expiration_date Contains invoice expiration date (cuold be null)
     * @return $this
     */
    public function setExpirationDate($expiration_date)
    {
        $this->container['expiration_date'] = $expiration_date;

        return $this;
    }

    /**
     * Gets retention_percentage
     * @return double
     */
    public function getRetentionPercentage()
    {
        return $this->container['retention_percentage'];
    }

    /**
     * Sets retention_percentage
     * @param double $retention_percentage The invoice retention percentage
     * @return $this
     */
    public function setRetentionPercentage($retention_percentage)
    {

        if (!is_null($retention_percentage) && ($retention_percentage > 100.0)) {
            throw new \InvalidArgumentException('invalid value for $retention_percentage when calling PublicInvoiceApiModel., must be smaller than or equal to 100.0.');
        }
        if (!is_null($retention_percentage) && ($retention_percentage < 0.0)) {
            throw new \InvalidArgumentException('invalid value for $retention_percentage when calling PublicInvoiceApiModel., must be bigger than or equal to 0.0.');
        }

        $this->container['retention_percentage'] = $retention_percentage;

        return $this;
    }

    /**
     * Gets footer
     * @return string
     */
    public function getFooter()
    {
        return $this->container['footer'];
    }

    /**
     * Sets footer
     * @param string $footer Invoice notes
     * @return $this
     */
    public function setFooter($footer)
    {
        $this->container['footer'] = $footer;

        return $this;
    }

    /**
     * Gets me
     * @return \Swagger\Client\Model\PublicInvoiceEntityApiModel
     */
    public function getMe()
    {
        return $this->container['me'];
    }

    /**
     * Sets me
     * @param \Swagger\Client\Model\PublicInvoiceEntityApiModel $me Information for the one generating the invoice
     * @return $this
     */
    public function setMe($me)
    {
        $this->container['me'] = $me;

        return $this;
    }

    /**
     * Gets target
     * @return \Swagger\Client\Model\PublicInvoiceEntityApiModel
     */
    public function getTarget()
    {
        return $this->container['target'];
    }

    /**
     * Sets target
     * @param \Swagger\Client\Model\PublicInvoiceEntityApiModel $target The information of the invoice destination
     * @return $this
     */
    public function setTarget($target)
    {
        $this->container['target'] = $target;

        return $this;
    }

    /**
     * Gets lines
     * @return \Swagger\Client\Model\PublicInvoiceLineApiModel[]
     */
    public function getLines()
    {
        return $this->container['lines'];
    }

    /**
     * Sets lines
     * @param \Swagger\Client\Model\PublicInvoiceLineApiModel[] $lines The line objects for the invoice
     * @return $this
     */
    public function setLines($lines)
    {
        $this->container['lines'] = $lines;

        return $this;
    }

    /**
     * Gets configuration
     * @return \Swagger\Client\Model\PublicInvoiceConfigurationApiModel
     */
    public function getConfiguration()
    {
        return $this->container['configuration'];
    }

    /**
     * Sets configuration
     * @param \Swagger\Client\Model\PublicInvoiceConfigurationApiModel $configuration The invoice configuration (optional)
     * @return $this
     */
    public function setConfiguration($configuration)
    {
        $this->container['configuration'] = $configuration;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
