<?php
/**
 * PublicInvoiceSharingOptionsApiModel
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * PublicInvoiceSharingOptionsApiModel Class Doc Comment
 *
 * @category    Class */
 // @description Defines the information for sharing the generated invoice
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class PublicInvoiceSharingOptionsApiModel implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'PublicInvoiceSharingOptionsApiModel';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'download' => 'bool',
        'send_by_email' => 'bool',
        'subscribe_to_newsletter' => 'bool',
        'custom_message' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'download' => 'download',
        'send_by_email' => 'sendByEmail',
        'subscribe_to_newsletter' => 'subscribeToNewsletter',
        'custom_message' => 'customMessage'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'download' => 'setDownload',
        'send_by_email' => 'setSendByEmail',
        'subscribe_to_newsletter' => 'setSubscribeToNewsletter',
        'custom_message' => 'setCustomMessage'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'download' => 'getDownload',
        'send_by_email' => 'getSendByEmail',
        'subscribe_to_newsletter' => 'getSubscribeToNewsletter',
        'custom_message' => 'getCustomMessage'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['download'] = isset($data['download']) ? $data['download'] : null;
        $this->container['send_by_email'] = isset($data['send_by_email']) ? $data['send_by_email'] : null;
        $this->container['subscribe_to_newsletter'] = isset($data['subscribe_to_newsletter']) ? $data['subscribe_to_newsletter'] : null;
        $this->container['custom_message'] = isset($data['custom_message']) ? $data['custom_message'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets download
     * @return bool
     */
    public function getDownload()
    {
        return $this->container['download'];
    }

    /**
     * Sets download
     * @param bool $download Set to true to download the invoice
     * @return $this
     */
    public function setDownload($download)
    {
        $this->container['download'] = $download;

        return $this;
    }

    /**
     * Gets send_by_email
     * @return bool
     */
    public function getSendByEmail()
    {
        return $this->container['send_by_email'];
    }

    /**
     * Sets send_by_email
     * @param bool $send_by_email Set to true to send the invoice by email. Requires the email information to be set on the entities information.
     * @return $this
     */
    public function setSendByEmail($send_by_email)
    {
        $this->container['send_by_email'] = $send_by_email;

        return $this;
    }

    /**
     * Gets subscribe_to_newsletter
     * @return bool
     */
    public function getSubscribeToNewsletter()
    {
        return $this->container['subscribe_to_newsletter'];
    }

    /**
     * Sets subscribe_to_newsletter
     * @param bool $subscribe_to_newsletter Set to true to subscribe the invoice issuer to platform newsletter
     * @return $this
     */
    public function setSubscribeToNewsletter($subscribe_to_newsletter)
    {
        $this->container['subscribe_to_newsletter'] = $subscribe_to_newsletter;

        return $this;
    }

    /**
     * Gets custom_message
     * @return string
     */
    public function getCustomMessage()
    {
        return $this->container['custom_message'];
    }

    /**
     * Sets custom_message
     * @param string $custom_message Defines a custom message to send to the invoice destination
     * @return $this
     */
    public function setCustomMessage($custom_message)
    {
        $this->container['custom_message'] = $custom_message;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
