<?php
/**
 * UpdateExpenseApiModel
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Contasimple API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * UpdateExpenseApiModel Class Doc Comment
 *
 * @category    Class */
 // @description Defines the information to update an expense
/**
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache License v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class UpdateExpenseApiModel implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'UpdateExpenseApiModel';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'number' => 'string',
        'date' => '\DateTime',
        'concept' => 'string',
        'amount' => 'double',
        'imputation' => 'int',
        'notes' => 'string',
        'expense_class' => 'int',
        'issuer_entity' => '\Swagger\Client\Model\ExpenseEntityApiModel'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'number' => 'number',
        'date' => 'date',
        'concept' => 'concept',
        'amount' => 'amount',
        'imputation' => 'imputation',
        'notes' => 'notes',
        'expense_class' => 'expenseClass',
        'issuer_entity' => 'issuerEntity'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'number' => 'setNumber',
        'date' => 'setDate',
        'concept' => 'setConcept',
        'amount' => 'setAmount',
        'imputation' => 'setImputation',
        'notes' => 'setNotes',
        'expense_class' => 'setExpenseClass',
        'issuer_entity' => 'setIssuerEntity'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'number' => 'getNumber',
        'date' => 'getDate',
        'concept' => 'getConcept',
        'amount' => 'getAmount',
        'imputation' => 'getImputation',
        'notes' => 'getNotes',
        'expense_class' => 'getExpenseClass',
        'issuer_entity' => 'getIssuerEntity'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['number'] = isset($data['number']) ? $data['number'] : null;
        $this->container['date'] = isset($data['date']) ? $data['date'] : null;
        $this->container['concept'] = isset($data['concept']) ? $data['concept'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['imputation'] = isset($data['imputation']) ? $data['imputation'] : null;
        $this->container['notes'] = isset($data['notes']) ? $data['notes'] : null;
        $this->container['expense_class'] = isset($data['expense_class']) ? $data['expense_class'] : null;
        $this->container['issuer_entity'] = isset($data['issuer_entity']) ? $data['issuer_entity'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if ($this->container['number'] === null) {
            $invalid_properties[] = "'number' can't be null";
        }
        if ($this->container['date'] === null) {
            $invalid_properties[] = "'date' can't be null";
        }
        if ($this->container['amount'] === null) {
            $invalid_properties[] = "'amount' can't be null";
        }
        if ($this->container['imputation'] === null) {
            $invalid_properties[] = "'imputation' can't be null";
        }
        if (($this->container['imputation'] > 100.0)) {
            $invalid_properties[] = "invalid value for 'imputation', must be smaller than or equal to 100.0.";
        }

        if (($this->container['imputation'] < 0.0)) {
            $invalid_properties[] = "invalid value for 'imputation', must be bigger than or equal to 0.0.";
        }

        if ($this->container['expense_class'] === null) {
            $invalid_properties[] = "'expense_class' can't be null";
        }
        if (($this->container['expense_class'] > 2.147483647E9)) {
            $invalid_properties[] = "invalid value for 'expense_class', must be smaller than or equal to 2.147483647E9.";
        }

        if (($this->container['expense_class'] < 1.0)) {
            $invalid_properties[] = "invalid value for 'expense_class', must be bigger than or equal to 1.0.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        if ($this->container['number'] === null) {
            return false;
        }
        if ($this->container['date'] === null) {
            return false;
        }
        if ($this->container['amount'] === null) {
            return false;
        }
        if ($this->container['imputation'] === null) {
            return false;
        }
        if ($this->container['imputation'] > 100.0) {
            return false;
        }
        if ($this->container['imputation'] < 0.0) {
            return false;
        }
        if ($this->container['expense_class'] === null) {
            return false;
        }
        if ($this->container['expense_class'] > 2.147483647E9) {
            return false;
        }
        if ($this->container['expense_class'] < 1.0) {
            return false;
        }
        return true;
    }


    /**
     * Gets number
     * @return string
     */
    public function getNumber()
    {
        return $this->container['number'];
    }

    /**
     * Sets number
     * @param string $number The expense number
     * @return $this
     */
    public function setNumber($number)
    {
        $this->container['number'] = $number;

        return $this;
    }

    /**
     * Gets date
     * @return \DateTime
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     * @param \DateTime $date Expense date
     * @return $this
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets concept
     * @return string
     */
    public function getConcept()
    {
        return $this->container['concept'];
    }

    /**
     * Sets concept
     * @param string $concept Brief description about what the expense was.
     * @return $this
     */
    public function setConcept($concept)
    {
        $this->container['concept'] = $concept;

        return $this;
    }

    /**
     * Gets amount
     * @return double
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     * @param double $amount The amount for the expense (including taxes).  There is a limit of two decimals.
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets imputation
     * @return int
     */
    public function getImputation()
    {
        return $this->container['imputation'];
    }

    /**
     * Sets imputation
     * @param int $imputation The percentage of the expense that will be involved in the fiscal computations.
     * @return $this
     */
    public function setImputation($imputation)
    {

        if (($imputation > 100.0)) {
            throw new \InvalidArgumentException('invalid value for $imputation when calling UpdateExpenseApiModel., must be smaller than or equal to 100.0.');
        }
        if (($imputation < 0.0)) {
            throw new \InvalidArgumentException('invalid value for $imputation when calling UpdateExpenseApiModel., must be bigger than or equal to 0.0.');
        }

        $this->container['imputation'] = $imputation;

        return $this;
    }

    /**
     * Gets notes
     * @return string
     */
    public function getNotes()
    {
        return $this->container['notes'];
    }

    /**
     * Sets notes
     * @param string $notes Some notes the use can input regarding the expense.
     * @return $this
     */
    public function setNotes($notes)
    {
        $this->container['notes'] = $notes;

        return $this;
    }

    /**
     * Gets expense_class
     * @return int
     */
    public function getExpenseClass()
    {
        return $this->container['expense_class'];
    }

    /**
     * Sets expense_class
     * @param int $expense_class The type of expense
     * @return $this
     */
    public function setExpenseClass($expense_class)
    {

        if (($expense_class > 2.147483647E9)) {
            throw new \InvalidArgumentException('invalid value for $expense_class when calling UpdateExpenseApiModel., must be smaller than or equal to 2.147483647E9.');
        }
        if (($expense_class < 1.0)) {
            throw new \InvalidArgumentException('invalid value for $expense_class when calling UpdateExpenseApiModel., must be bigger than or equal to 1.0.');
        }

        $this->container['expense_class'] = $expense_class;

        return $this;
    }

    /**
     * Gets issuer_entity
     * @return \Swagger\Client\Model\ExpenseEntityApiModel
     */
    public function getIssuerEntity()
    {
        return $this->container['issuer_entity'];
    }

    /**
     * Sets issuer_entity
     * @param \Swagger\Client\Model\ExpenseEntityApiModel $issuer_entity Contains the expense entity identifier
     * @return $this
     */
    public function setIssuerEntity($issuer_entity)
    {
        $this->container['issuer_entity'] = $issuer_entity;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}
